﻿using System.Collections.Generic;
using System.Linq;

namespace Moriarty.Msrc
{
    public class CVE_2020_0796 : IVulnerabilityCheck
    {
        private const string Id = "CVE-2020-0796";
        private static readonly string[] Exploits = new[]
        {
            "https://github.com/jamf/CVE-2020-0796-RCE-POC"
        };

        public Vulnerability GetVulnerability()
        {
            return new Vulnerability(Id, Exploits);
        }

        public void Check(VulnerabilityCollection vulnerabilities, int BuildNumber, List<int> installedKBs)
        {
            List<int> Supersedence = new List<int>();

            switch (BuildNumber)
            {
                case 18362:
                case 18363:

                    Supersedence.AddRange(new int[] {
                        4551762
                    });

                    break;

                default:
                    return;
            }

            IEnumerable<int> x = Supersedence.Intersect(installedKBs);

            if (!x.Any())
                vulnerabilities.SetAsVulnerable(Id);
        }
    }
}