﻿using System.Collections.Generic;
using System.Linq;

namespace Moriarty.Msrc
{
    public class CVE_2020_1013 : IVulnerabilityCheck
    {
        private const string Id = "CVE-2020-1013";
        private static readonly string[] Exploits = new[]
        {
            "https://www.gosecure.net/blog/2020/09/08/wsus-attacks-part-2-cve-2020-1013-a-windows-10-local-privilege-escalation-1-day/"
        };

        public Vulnerability GetVulnerability()
        {
            return new Vulnerability(Id, Exploits);
        }

        public void Check(VulnerabilityCollection vulnerabilities, int buildNumber, List<int> installedKBs)
        {
            var supersedence = new List<int>();

            switch (buildNumber)
            {
                case 10240:

                    supersedence.AddRange(new int[] {
                        4577049
                    });

                    break;

                case 14393:

                    supersedence.AddRange(new int[] {
                        4577015
                    });

                    break;

                case 16299:

                    supersedence.AddRange(new int[] {
                        4577041
                    });

                    break;

                case 17134:

                    supersedence.AddRange(new int[] {
                        4577032
                    });

                    break;

                case 17763:

                    supersedence.AddRange(new int[] {
                        4570333, 4577069
                    });

                    break;

                case 18362:

                    supersedence.AddRange(new int[] {
                        4574727, 4577062
                    });

                    break;

                case 18363:

                    supersedence.AddRange(new int[] {
                        4574727, 4577062
                    });

                    break;

                case 19041:

                    supersedence.AddRange(new int[] {
                        4571756, 4577063
                    });

                    break;

                default:
                    return;
            }

            if (supersedence.Intersect(installedKBs).Any())
            {
                vulnerabilities.SetAsVulnerable(Id);
            }
        }
    }
}